#include <iostream>
#include<vector>
#include"Session-RH.h"
#include"stdlib.h"
#include"time.h"


#include"invokeZchaff.c"

/*
extern "C" {
#include"invokeZchaff.c"
}
*/

using namespace std;



int clause_size(const vector<int> &);
int PUB_PLB_size(char* );
int session_satisfiability(char* , int, int, int,int, double &);
char* print2file(const vector<int> &, int, int);
int Roles_size(char* );
void printVector(const vector<int> &v);

//MAIN()

int main(){
    
	char ** InputFile = new char*[10];

	for (int i=0; i<10; i++){

              InputFile[i]= new char[20];
	}

	strcpy(InputFile[0],"session-1.txt");
	strcpy(InputFile[1],"session-2.txt");
	strcpy(InputFile[2],"session-3.txt");
	strcpy(InputFile[3],"session-4.txt");
	strcpy(InputFile[4],"session-5.txt");
	strcpy(InputFile[5],"session-6.txt");
	strcpy(InputFile[6],"session-7.txt");
	strcpy(InputFile[7],"session-8.txt");
	strcpy(InputFile[8],"session-9.txt");
	strcpy(InputFile[9],"session-10.txt");
	

	int range_beg_perm, range_end_perm, range_beg_role, range_end_role;  
	int k_perm, k_role, opt_k_role, opt_k_perm, k_exst_perm, k_exst_role;
	int result;

        double runTime, TotalrunTime, Sum_Time, Sum_Time_square;  // runTime = running time of each iteration in binary search 
	double avg_time, var_time, Second_moment, Total_avg, Total_var, avg_Second_moment; // TotalrunTime = total runtime of a binary search
						 // Sum_time = sum of TotalrunTime for num_itr times of calling binary search
	int num_itr=10;		
	int num_files=10;
	    Total_avg=0;
	    Total_var=0;
	    avg_Second_moment=0;

	for(int i=0; i< num_files ; i++){


		Sum_Time=0;
		Sum_Time_square=0;

		for (int j=0; j< num_itr; j++){

                	range_beg_perm = 0;
                	range_end_perm = PUB_PLB_size(InputFile[i]);
    
 
			range_beg_role = 1;	
                	range_end_role = Roles_size(InputFile[i]);

               
       			TotalrunTime = 0;
       			k_exst_perm = 0; 

			opt_k_perm = range_end_perm;
			opt_k_role = range_end_role;


       			while (range_end_perm >= range_beg_perm){
             
             				k_perm = (range_beg_perm + range_end_perm)/2;

             				result = session_satisfiability(InputFile[i], range_end_role, k_perm, 0, 0, runTime);	     		

             				TotalrunTime += runTime;

             				if ( result == 0){
                       
                       				range_beg_perm = k_perm+1;
                       				//range_end=range_end;
			
                       
             				}else if (result == 1){
                    
                       				opt_k_perm = k_perm;
						cout << " opt_k_perm = " << opt_k_perm <<endl;
                       				k_exst_perm = 1;
                       				//range_beg=range_beg;
                       				range_end_perm = k_perm-1;
                       
             				}else if (result == -1){
                      
                      				k_exst_perm = -1;
                      				break;
             				}
             
      		        }
			
			if (k_exst_perm == -1){
 
					cout << " ERROR exists " << endl;
					break;
			}

/*
			if (k_exst_perm ==0){ 
				
					break;
			}
*/

			while(range_end_role >= range_beg_role){

					k_role = (range_end_role + range_beg_role )/2;	
					
             				result = session_satisfiability(InputFile[i], k_role, opt_k_perm , 0, 0, runTime);	     		
             				TotalrunTime += runTime;

             				if ( result == 0){
                       
                       				range_beg_role = k_role+1;
                       				//range_end=range_end;
			
                       
             				}else if (result == 1){
                    
                       				opt_k_role = k_role;
						cout << "opt_k_role = " << opt_k_role << endl;
                       				k_exst_role = 1;
                       				//range_beg=range_beg;
                       				range_end_role = k_role-1;
                       
             				}else if (result == -1){
                      
                      				k_exst_role = -1;
                      				break;
             				}
             
      		        }
			
			if (k_exst_role == -1){
 
					cout << " ERROR exists " << endl;
					break;
 
			}

			Sum_Time += TotalrunTime;
			Sum_Time_square += (TotalrunTime * TotalrunTime) ; 

		 }


		 avg_time = Sum_Time/num_itr;

//		 var_time = Sum_Time_square/num_itr - avg_time * avg_time;

		 Second_moment = Sum_Time_square/ num_itr;   

/*
		cout << "Result for " << InputFile[i] << endl;

       		if (k_exst_perm == 1 && k_exst_role == 1 ){
                  
             		cout << " OPT (k_role, k_perm)  = (" << opt_k_role << ", "  << opt_k_perm << ")" << endl;

       		}else if(k_exst_perm !=-1 && k_exst_role != -1 )  {
             
             		cout << " No such k exists " << endl;

       		}

		cout << "Average Time Elapsed = " << avg_time << endl;
		cout << "Variance of Time Elapsed = " << var_time << endl;
		cout <<"======================" << endl;
*/
	
		Total_avg += avg_time/num_files; 
		avg_Second_moment += Second_moment/num_files; 



	}


	Total_var = avg_Second_moment - Total_avg * Total_avg;
	
	cout << "Total Average = " << Total_avg << endl << " Total Var " << Total_var << endl;


	for (int i=0; i<10; i++){
		delete InputFile[i];
	}

	delete InputFile;


return 0;       
}


// 
int PUB_PLB_size(char* InputFile){
       
       vector<int> PUB_PLB;
       int x;
       string str;    
     
       ifstream input;
       input.open(InputFile);
       
       if (!input){
                
         cerr << InputFile <<" not found " << endl;
         exit(1);
       }
                 
       while (str.compare("#PUB-PLB")!=0 ) getline(input,str);
     
       getline(input,str);
       stringstream lineStream(str);
       
       while (lineStream >> x){
                
           PUB_PLB.push_back(x);
          
       }           
       
       return  PUB_PLB.size();           
}
               


int Roles_size(char* InputFile ){
	
	int size;
	string str;

	ifstream input;
	input.open(InputFile);

	if (!input){

		cerr << InputFile << " not found " << endl;
		exit(1);
	}


	while(str.compare("#R")!=0) getline(input,str);
	
	getline(input,str);
	stringstream LineStream(str);

	LineStream >> size;


return size;

}


               
//

int session_satisfiability(char* InputFile, int k_role, int k_perm, int Obj_role, int Obj_perm, double & runTime){
    
       Session tester(InputFile, k_role, k_perm, Obj_role, Obj_perm);

       unsigned t0 = clock(), t1;
       tester.Generate_CNF();  
       t1=clock();
       double runTime1= double(t1-t0)/CLOCKS_PER_SEC; 
       
       int num_clauses=clause_size(tester.CNF); 
       int num_vars = tester.free_index-1;
       char* OutFile=print2file(tester.CNF, num_vars, num_clauses);
	       

       double runTime2;
       int result=invokeZchaff(OutFile, runTime2);

       if (result == -1) cout << endl << " not successful call on Zchaff" << endl;


 
   	runTime=runTime1+runTime2;

//	if (k_perm == 0) printVector(tester.CNF);

   return result;    

}               


int clause_size(const vector<int> &v){
    
    int num_clauses=0;
    
    for(int i=0; i<v.size() ; i++){

           if (v[i]==0 ){
                       
                   num_clauses++;
           }
     }
   
return num_clauses;    
}






char* print2file(const vector<int> &v, int num_vars, int num_clauses){

     char* OutFile=new char[20];
     strcpy(OutFile,"cnf.txt");

     ofstream myoutstream;
     myoutstream.open(OutFile,ios::trunc);
     
     myoutstream << "p cnf " << num_vars << " " << num_clauses <<endl;
     
     for(int i=0; i<v.size() ; i++){

           myoutstream << v.at(i) <<" " ;

           if (v.at(i)==0 ){
               myoutstream << endl;
           }
     }
      
     myoutstream.flush();
     myoutstream.close(); 
     
return OutFile; 
}



void printVector(const vector<int> &v) {

      for(int i=0; i<v.size() ; i++){


           cout << v[i] <<" " ;

           if (v[i]==0 ){

               cout << endl;
           }
      }
}

